#ifndef XFIG_H_INCLUDED
#define XFIG_H_INCLUDED

#include <stdio.h>
#include "vektor.h"
#include <string>

// In time this class should also be used in renderer.cpp and in ep_xfig.cpp

class XFig
{
  FILE *f;
  IntegerVectorList p;
  bool arrowOrigin;
  bool arrowTarget;
 public:
  XFig(FILE *f_):
    f(f_)
    {
      fprintf(f,"#FIG 3.2\n"
	      "Landscape\n"
	      "Center\n"
	      "Inches\n"
	      "Letter\n"
	      "100.00\n"
	      "Single\n"
	      "-2\n"
	      "1200 2\n");
    }
  void beginDrawLine(bool arrowOrigin_=false, bool arrowTarget_=false)
    {
      arrowOrigin=arrowOrigin_;
      arrowTarget=arrowTarget_;
      fprintf(f,"2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 %i %i",int(arrowTarget),int(arrowOrigin));
    }
  void addPoint(int x, int y)
    {
      IntegerVector v(2);
      v[0]=x;
      v[1]=y;
      p.push_back(v);
    }
  void endDrawLine()
    {
      assert(p.size()>0);
      fprintf(f," %i\n",p.size());
      if(arrowOrigin)
	fprintf(f,"\t 2 1 1.00 60.00 120.00\n");
      if(arrowTarget)
	fprintf(f,"\t 2 1 1.00 60.00 120.00\n");
      for(IntegerVectorList::const_iterator i=p.begin();i!=p.end();i++)
	{
	  fprintf(f," %i %i",(*i)[0],(*i)[1]);
	}
      p=IntegerVectorList();
      fprintf(f,"\n");
    }
  void drawString(int x, int y, string const &s)
    {
      fprintf(f,"4 0 0 50 -1 0 12 0.0000 4 135 270 %i %i ",x,y);
      fprintf(f,"%s",s.c_str());
      fprintf(f,"\\001\n");
    }   
  void drawDot(int x, int y)
    {
      fprintf(f,"1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 %i %i 75 75 %i %i %i %i\n",x,y,x,y,x+75,y);
    }
};


#endif
